{% extends 'site_base.html' %}
{% load static %}
{% load crispy_forms_tags %}

{% block content %}

    <div class="box box-primary">
        <head>
            <title>
                {% block title %}
                    {% if sales %}
                        Edit Dealer Monthly Target
                    {% else %}
                        Create Dealer Monthly Target
                    {% endif%}
                {% endblock %}
            </title>
        </head>
        <div class="box-header with-border">
            <span id="btn-back" class="glyphicon glyphicon-circle-arrow-left"></span>
            {% if sales %}
            <h3 class="box-title"> <p>Edit Dealer Monthly Target</p> </h3>
            {% else %}
            <h3 class="box-title"> <p>Create Dealer Monthly Target</p> </h3>
            {% endif %}
        </div>

        <form id="myForm" method="post" novalidate>
            {% csrf_token %}
            <div class="box-body">
                <div class="form-group col-md-12 col-sm-12">
                    {% if sales %}
                    <div class="form-group">
                        <label class="control-label">Dealer Code</label>
                        <div class="controls">
                            <input type="text"  value="{{sales.dealer.user_code}}" class="form-control"  readonly>
                            <input type="hidden" name="dealer" value="{{sales.dealer.id}}" class="form-control" readonly/>
                        </div>
                    </div>

                    {% else %}
                    <div class="form-group">
                        <label class="control-label ">Dealer Code*</label>
                        <div class="controls ">
                            <select id="id_dealer" class="select form-control" name="dealer">
                                <option value="">---------</option>
                                {% for user in users %}
                                <option value="{{user.id}}">{{ user.user_code }}</option>
                                {% endfor %}
                            </select>
                        </div>
                    </div>
                    {% endif %}
                </div>

                <div class="form-group col-md-12 col-sm-12">
                    <div id="div_id_product_category"
                         class="form-group {% if dealer_sales_target_create_form.category.errors %} has-error {% endif %}">
                        <label for="id_product_category" class="control-label requiredField">
                            Product Category <span class="asteriskField">*</span>
                        </label>
                        <div class="controls">
                            <div id="product_category_app">
                                <treeselect id="id_product_category" name="category" :multiple="false"
                                            :options="options"
                                            placeholder="Select Product Category..." v-model="selected_category"
                                            :load-options="loadOptions"/>
                            </div>
                            {% for x in dealer_sales_target_create_form.category.errors %}
                            <p class="help-block"><strong>{{x}}</strong></p>
                            {% endfor %}
                        </div>
                    </div>
                </div>

                <div class="form-group col-md-12 col-sm-12">
                    <input type="hidden" name="brand" id="txtbrand">
                    {{dealer_sales_target_create_form.monthly_target|as_crispy_field}}
                </div>

                <div class="form-group col-md-12 col-sm-12 text-right">
                    <input type="submit" value="Submit" class="btn btn-primary"/>
                </div>
            </div>
        </form>
    </div>

{% endblock %}


{% block extra_style_block %}
    {{ block.super }}
    <script src="{% static 'plugins/vue/vue.min.js' %}"></script>
    <script src="{% static 'plugins/vue/treeview/vue-treeselect.min.js' %}"></script>
    <link href="{% static 'plugins/vue/treeview/vue-treeselect.min.css' %}" rel="stylesheet"/>
{% endblock %}


{% block extra_script_block %}
    {{ block.super }}
    <script>
        var category_list = [];
        $(document).ready(function(){
            $('#txtbrand').val($("#top_brand").val());

            $.ajax({
                type:'get',
                url:'/master/get/product_category',
                success: function(res){
                    category_list = JSON.parse(res);
                    initTreeView();
                }
            });

            $("#myForm").submit(function(event) {

                 var flag = false;

                 if($('#id_dealer').val() == ""){
                     $('#id_dealer').parent().parent().addClass('has-error')
                     $('#error_1_id_dealer').remove();
                     $('#id_dealer').parent().append('<p id="error_1_id_dealer" class="help-block"><strong>This field is required.</strong></p>');
                     flag = false;
                 }
                 else {
                     $('#id_dealer').parent().parent().removeClass('has-error')
                     $('#error_1_id_dealer').remove();
                     flag = true;
                 }
                 return flag;
             });
        });

        function initTreeView(){
            Vue.component('treeselect', VueTreeselect.Treeselect);
            const sleep = d => new Promise(r => setTimeout(r, d));
            let called = false;
            let tree = new Vue({
                el: '#product_category_app',
                data: {
                    selected_category: {% if dealer_sales_target_create_form.category.value %} {{dealer_sales_target_create_form.category.value}} {% else %} null {% endif %},
                    options: null
                },
                watch: {
                    'selected_category': function(newVal, oldVal){
                        console.log(newVal);
                        $("#id_product_category").val(newVal);
                    }
                },
                methods: {
                    async loadOptions({ action/*, callback*/ }) {
                        if (action === 'LOAD_ROOT_OPTIONS') {

                            if (!called) {
                                await sleep(1000) // Simulate an async operation.
                                called = true
                                $.ajax({
                                    type:'get',
                                    url:'/master/get/product_category',
                                    success: function(res) {
                                        tree.options = JSON.parse(res);
                                    }, error: function(err) {
                                        throw new Error('Failed to load options: test.')
                                    }
                                });
                            }
                            else {
                                $.ajax({
                                    type:'get',
                                    url:'/master/get/product_category',
                                    success: function(res){
                                        tree.options = JSON.parse(res);
                                    }, error: function(err){
                                        throw new Error('Failed to load options: test.')
                                    }
                                });
                            }
                        }
                    },
                }
            });
        }
    </script>
{% endblock %}